# uBlock

The uBlock ad blocking web extension is contained here.

# Building

Install [Node](https://nodejs.org), cd into the project root and run:

- `npm install` - install dependencies.
- `npm run subscriptions` - download and configure manifest v3 subscriptions and rulesets.
- `npm run rules` - generate mv2 rules to include in the extension (relies on the filter lists downloaded using `npm run subscriptions`).
- `npm run build` creates the exploded extensions in the `/bundles/&lt;browser&gt;` directories.

# Upgrading EWE

In order to upgrade EWE upgrade the npm dependency using `npm install @eyeo/webext-sdk`.

# Development

Directory layout:

- `/src` - source files for the extension (no build required)
- `/test` - Jest test files
- `/manifest` - browser specific manifest.json files
- `/build` - scripts that support building the extension for app store submission
- `/dist` - build products are produced here

The project uses Jest for unit tests, eslint with standard recommended rules, and Prettier for formatting.

Normal development workflow:

- `npm run subscriptions` - update subscriptions and rulesets (only needs to be done daily/weekly)
- `npm run rules` - update hiding rules (only needs to be done daily/weekly when subscriptions is updated)
- `npm run dev` - dynamically builds the extension
- `web-ext run` - in the `dist` directory watches and hot reloads the extension in Firefox.
- `npm test` - to run unit tests.

To create a deployment

- `npm run subscriptions` - update subscriptions and rulesets
- `node run build` - to build extensions bundles for all supported browsers

# Snippets

> TODO integrate snippets updates into the `tools/subscriptions.js` script
