export class Guardian {
  constructor() {
    this.lastError = "";
    this.status = {};
  }

  setLastError(msg) {
    switch (typeof msg) {
      case "string":
        this.lastError = msg;
        break;
      case "object":
        if (msg.error) {
          switch (typeof msg.error) {
            case "string":
              this.lastError = msg.error;
              break;
            case "object":
              if (typeof msg.error.string === "function") {
                this.lastError = msg.error.string();
              } else if (typeof msg.error.toString === "function") {
                this.lastError = msg.error.toString();
              } else {
                this.lastError = JSON.stringify(msg.error);
              }
              break;
          }
        } else {
          if (typeof msg.string === "function") {
            this.lastError = msg.string();
          } else if (typeof msg.toString === "function") {
            this.lastError = msg.toString();
          } else {
            this.lastError = JSON.stringify(msg);
          }
        }
        break;
      default:
        return;
    }
  }

  getLastError() {
    return this.lastError;
  }

  /**
   * Sets a key on the status.
   *
   * @param key {String} status key to store setting
   * @param value {String|number|Boolean} status value to set
   */
  setStatus(key, value) {
    this.status[key] = value;
  }

  /**
   * Retrieve the status of the system.
   *
   * @return {*|{}}
   */
  getStatus() {
    return this.status;
  }
}
